# MariaDB Connector/Python

<!-- import mariadb
conn_params= {
    "host" : "localhost",
    "database" : "test"
}

conn=mariadb.connect(**conn_params)
cursor=conn.cursor()
cursor.execute("CREATE USER IF NOT EXISTS example_user@localhost identified by 'GHbe_Su3B8'")
cursor.execute("grant all on test.* to example_user@localhost")
cursor.execute("DROP TABLE IF EXISTS book")
cursor.close()
conn.close() -->

MariaDB Connector/Python enables python programs to access MariaDB and MySQL databases, using an API
which is compliant with the Python DB API 2.0 (:PEP:`249`). It is written in C and Python and uses
MariaDB Connector/C client library for client server communication.

### Contents

# Contents:

* [Installation](install.md)
  * [Prerequisites](install.md#prerequisites)
  * [Binary installation](install.md#binary-installation)
    * [Microsoft Windows](install.md#microsoft-windows)
  * [Installation from Source](install.md#installation-from-source)
    * [Build prerequisites](install.md#build-prerequisites)
  * [Test suite](install.md#test-suite)
* [Basic usage](usage.md)
  * [Connecting](usage.md#connecting)
  * [Passing parameters to SQL statements](usage.md#passing-parameters-to-sql-statements)
    * [Using indicators](usage.md#using-indicators)
* [Connection pooling](pooling.md)
  * [Configuring and using a connection pool](pooling.md#configuring-and-using-a-connection-pool)
    * [Creating a connection pool](pooling.md#creating-a-connection-pool)
* [API Reference](api.md)
  * [The MariaDB Connector/Python module](module.md)
    * [Constructors](module.md#constructors)
    * [Attributes](module.md#attributes)
    * [Exceptions](module.md#exceptions)
  * [The connection class](connection.md)
    * [`Connection`](connection.md#mariadb.connections.Connection)
    * [Connection constructors](connection.md#connection-constructors)
    * [Connection methods](connection.md#connection-methods)
    * [Connection attributes](connection.md#connection-attributes)
  * [The cursor class](cursor.md)
    * [`Cursor`](cursor.md#mariadb.cursors.Cursor)
    * [Cursor methods](cursor.md#cursor-methods)
    * [Cursor attributes](cursor.md#cursor-attributes)
  * [The ConnectionPool class](pool.md)
    * [`ConnectionPool`](pool.md#mariadb.ConnectionPool)
    * [ConnectionPool methods](pool.md#connectionpool-methods)
    * [ConnectionPool attributes](pool.md#connectionpool-attributes)
  * [Constants](constants.md)
    * [CAPABILITY](constants.md#capability)
    * [CLIENT](constants.md#client)
    * [CURSOR](constants.md#cursor)
    * [ERR (Error)](constants.md#err-error)
    * [FIELD_FLAG](constants.md#field-flag)
    * [FIELD_TYPE](constants.md#module-mariadb.constants.FIELD_TYPE)
    * [INDICATORS](constants.md#indicators)
    * [INFO](constants.md#info)
    * [TPC_STATE](constants.md#tpc-state)
    * [STATUS](constants.md#status)
* [License](license.md)
  * [MariaDB Connector/Python](license.md#mariadb-connector-python)
  * [MariaDB Connector/Python documentation](license.md#mariadb-connector-python-documentation)
* [Release history](release.md)
  * [MariaDB Connector/Python 1.1.11](release.md#mariadb-connector-python-1-1-11)
  * [MariaDB Connector/Python 1.1.10](release.md#mariadb-connector-python-1-1-10)
  * [MariaDB Connector/Python 1.1.9](release.md#mariadb-connector-python-1-1-9)
  * [MariaDB Connector/Python 1.1.8](release.md#mariadb-connector-python-1-1-8)
  * [MariaDB Connector/Python 1.1.7](release.md#mariadb-connector-python-1-1-7)
  * [MariaDB Connector/Python 1.1.6](release.md#mariadb-connector-python-1-1-6)
  * [MariaDB Connector/Python 1.1.5](release.md#mariadb-connector-python-1-1-5)
  * [MariaDB Connector/Python 1.1.4](release.md#mariadb-connector-python-1-1-4)
  * [MariaDB Connector/Python 1.1.3](release.md#mariadb-connector-python-1-1-3)
  * [MariaDB Connector/Python 1.1.2](release.md#mariadb-connector-python-1-1-2)
  * [MariaDB Connector/Python 1.0.11](release.md#mariadb-connector-python-1-0-11)
  * [MariaDB Connector/Pyhon 1.0.10](release.md#mariadb-connector-pyhon-1-0-10)
  * [MariaDB Connector/Python 1.0.9](release.md#mariadb-connector-python-1-0-9)
  * [MariaDB Connector/Python 1.0.8](release.md#mariadb-connector-python-1-0-8)
  * [MariaDB Connector/Python 1.0.7](release.md#mariadb-connector-python-1-0-7)
  * [MariaDB Connector/Python 1.0.6](release.md#mariadb-connector-python-1-0-6)
  * [MariaDB Connector/Python 1.0.5](release.md#mariadb-connector-python-1-0-5)
  * [MariaDB Connector/Python 1.0.4](release.md#mariadb-connector-python-1-0-4)
  * [MariaDB Connector/Python 1.0.3](release.md#mariadb-connector-python-1-0-3)
  * [MariaDB Connector/Python 1.0.2](release.md#mariadb-connector-python-1-0-2)
  * [MariaDB Connector/Python 1.0.1](release.md#mariadb-connector-python-1-0-1)
  * [MariaDB Connector/Python 1.0.0](release.md#mariadb-connector-python-1-0-0)
* [Bug reports](bugs.md)
  * [How to report a bug?](bugs.md#how-to-report-a-bug)
    * [Search first](bugs.md#search-first)
    * [What?](bugs.md#what)
    * [Versions of components](bugs.md#versions-of-components)
    * [Avoid screenshots!](bugs.md#avoid-screenshots)
    * [Keep it simple!](bugs.md#keep-it-simple)
    * [Only report one problem in one bug report](bugs.md#only-report-one-problem-in-one-bug-report)
    * [Crashes](bugs.md#crashes)
    * [Report bugs in English only!](bugs.md#report-bugs-in-english-only)
* [MariaDB Connector/Python FAQ](faq.md)
  * [Installation](faq.md#installation)
  * [Connecting](faq.md#connecting)
  * [General:](faq.md#general)
  * [Transactions](faq.md#transactions)

## Indices and tables

- [Index](genindex.md)
- [Module Index](py-modindex.md)
- [Search Page](search.md)
